const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Login_logsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const login_logs = await db.login_logs.create(
      {
        id: data.id || undefined,

        login_time: data.login_time || null,
        ip_address: data.ip_address || null,
        device_info: data.device_info || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await login_logs.setUser(data.user || null, {
      transaction,
    });

    await login_logs.setSchools(data.schools || null, {
      transaction,
    });

    return login_logs;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const login_logsData = data.map((item, index) => ({
      id: item.id || undefined,

      login_time: item.login_time || null,
      ip_address: item.ip_address || null,
      device_info: item.device_info || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const login_logs = await db.login_logs.bulkCreate(login_logsData, {
      transaction,
    });

    // For each item created, replace relation files

    return login_logs;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const login_logs = await db.login_logs.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.login_time !== undefined)
      updatePayload.login_time = data.login_time;

    if (data.ip_address !== undefined)
      updatePayload.ip_address = data.ip_address;

    if (data.device_info !== undefined)
      updatePayload.device_info = data.device_info;

    updatePayload.updatedById = currentUser.id;

    await login_logs.update(updatePayload, { transaction });

    if (data.user !== undefined) {
      await login_logs.setUser(
        data.user,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await login_logs.setSchools(
        data.schools,

        { transaction },
      );
    }

    return login_logs;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const login_logs = await db.login_logs.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of login_logs) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of login_logs) {
        await record.destroy({ transaction });
      }
    });

    return login_logs;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const login_logs = await db.login_logs.findByPk(id, options);

    await login_logs.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await login_logs.destroy({
      transaction,
    });

    return login_logs;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const login_logs = await db.login_logs.findOne({ where }, { transaction });

    if (!login_logs) {
      return login_logs;
    }

    const output = login_logs.get({ plain: true });

    output.user = await login_logs.getUser({
      transaction,
    });

    output.schools = await login_logs.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.users,
        as: 'user',

        where: filter.user
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.user
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.user
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.ip_address) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('login_logs', 'ip_address', filter.ip_address),
        };
      }

      if (filter.device_info) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'login_logs',
            'device_info',
            filter.device_info,
          ),
        };
      }

      if (filter.login_timeRange) {
        const [start, end] = filter.login_timeRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            login_time: {
              ...where.login_time,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            login_time: {
              ...where.login_time,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.login_logs.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('login_logs', 'ip_address', query),
        ],
      };
    }

    const records = await db.login_logs.findAll({
      attributes: ['id', 'ip_address'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['ip_address', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.ip_address,
    }));
  }
};
